#lang racket
(require "test.rkt")

;; find-val : list-of-(cons X Y) X -> Y-or-false
(define (find-val lst key)
  (cond
    [(empty? lst) #f]
    [else (if (equal? (car (car lst)) key)
              (cdr (car lst))
              (find-val (cdr lst) key))]))

(test (find-val '((x . 1) (y . 2) (z . 3)) 'x) 1)
(test (find-val '((x . 1) (y . 2) (z . 3)) 'a) #f)
(test (find-val '((x . 1) (y . #f) (z . 3)) 'y) #f)
(test (find-val '((x . 1) (y . #f) (z . 3)) 'a) #f)

;; A failure continuation lets us distinguish finding 
;;  a value #f from not finding a value: 

;; find-val* : list-of-(cons X Y) X (-> Y) -> Y
(define (find-val* lst key fail-k)
  (cond
    [(empty? lst) (fail-k)]
    [else (if (equal? (car (car lst)) key)
              (cdr (car lst))
              (find-val* (cdr lst) key fail-k))]))

(test (find-val* '((x . 1) (y . 2) (z . 3)) 'x (lambda () #f)) 
      1)
(test (find-val* '((x . 1) (y . 2) (z . 3)) 'a  (lambda () #f)) 
      #f)
(test (find-val* '((x . 1) (y . #f) (z . 3)) 'y (lambda () 'not-there))
      #f)
(test (find-val* '((x . 1) (y . #f) (z . 3)) 'a (lambda () 'not-there))
      'not-there)

(run-tests)
